<script lang="ts">
    import Dashboard from "./lib/Dashboard.svelte";
    import {v4 as uuidv4, validate as uuidValidate} from 'uuid';
    import {onMount} from "svelte";
    import Welcome from "./lib/Welcome.svelte";

    let uuid

    let loading = false

    let initialize = false

    function loadList(fragment: string) {
        const database = `${window.location.protocol}//${window.location.host}/_users/org.couchdb.user:${fragment}`
        loading = true
        fetch(database, {
            method: 'PUT',
            headers: {
                "Accept": "application/json",
                "Content-Type": "application/json"
            },
            body: JSON.stringify({name: fragment, password: 'apple', roles: [], type: 'user'})
        }).then((response) => {
            loading = false
            // 201 created -- created; initialize db
            if (response.status === 201) {
                initialize = true
                uuid = fragment
            } else if (response.status === 409) {
                // 409 conflict -- already exists, all good
                uuid = fragment
            } else {
                // else (403, etc.) -- error
            }
        })
    }

    function createAndLoadList() {
        const newUUID = uuidv4()
        localStorage.setItem("manana-db", newUUID)
        loadList(newUUID)
    }

    function deleteList() {
        localStorage.removeItem("manana-db")
        uuid = undefined
    }

    onMount(() => {
        const fragment = window.location.hash.substring(1)
        if (uuidValidate(fragment)) {
            localStorage.setItem("manana-db", fragment)
            loadList(fragment)
        } else {
            // window.location.replace('#')
            const saved_name = localStorage.getItem("manana-db")
            if (saved_name !== null) {
                loadList(saved_name)
            }
        }
    })
</script>

<main class="container">
    {#if loading}
        <h1 class="title">ma·ña·na</h1>

        <div class="columns mt-5 pt-5">
            <div class="column is-half is-offset-one-quarter has-text-centered">
                <h2 class="subtitle">Loading</h2>
                <progress class="progress is-primary" max="100">15%</progress>
            </div>
        </div>
    {:else if uuid === undefined}
        <Welcome on:createList={() => createAndLoadList()}/>
    {:else}
        <Dashboard {uuid} {initialize} on:delete={() => deleteList()}/>
    {/if}
</main>

<style>
    main {
        padding: 2rem
    }
</style>